// Keypad functions (with 74C922)
// Chin-Shiuh Shieh on 2014-11-30

#define KEYPAD_D0 2
#define KEYPAD_D1 3
#define KEYPAD_D2 4
#define KEYPAD_D3 5
#define KEYPAD_DA 6

#define KEYPAD_NULL 0x10

const char ASCII[]="0123456789ABCDEF";

unsigned char keypad_get_key(void){
  unsigned char key;
  pinMode(KEYPAD_D0,INPUT);pinMode(KEYPAD_D1,INPUT);pinMode(KEYPAD_D2,INPUT);pinMode(KEYPAD_D3,INPUT);pinMode(KEYPAD_DA,INPUT);
  while(digitalRead(KEYPAD_DA)==LOW);
  key=digitalRead(KEYPAD_D3)*8+digitalRead(KEYPAD_D2)*4+digitalRead(KEYPAD_D1)*2+digitalRead(KEYPAD_D0);
  while(digitalRead(KEYPAD_DA)==HIGH);
  return key;
}

unsigned char keypad_get_key_echo(void){
  unsigned char key;
  pinMode(KEYPAD_D0,INPUT);pinMode(KEYPAD_D1,INPUT);pinMode(KEYPAD_D2,INPUT);pinMode(KEYPAD_D3,INPUT);pinMode(KEYPAD_DA,INPUT);
  while(digitalRead(KEYPAD_DA)==LOW);
  key=digitalRead(KEYPAD_D3)*8+digitalRead(KEYPAD_D2)*4+digitalRead(KEYPAD_D1)*2+digitalRead(KEYPAD_D0);
  Serial.write(ASCII[key]);
  while(digitalRead(KEYPAD_DA)==HIGH);
  return key;
}

unsigned char keypad_get_byte(void){
  return(keypad_get_key_echo()*16+keypad_get_key_echo());
}

unsigned int keypad_get_word(void){
  return(keypad_get_byte()*256+keypad_get_byte());
}

unsigned char keypad_check_key(void){
  unsigned char key;
  pinMode(KEYPAD_D0,INPUT);pinMode(KEYPAD_D1,INPUT);pinMode(KEYPAD_D2,INPUT);pinMode(KEYPAD_D3,INPUT);pinMode(KEYPAD_DA,INPUT);
  if(digitalRead(KEYPAD_DA)==HIGH){
    key=digitalRead(KEYPAD_D3)*8+digitalRead(KEYPAD_D2)*4+digitalRead(KEYPAD_D1)*2+digitalRead(KEYPAD_D0);
    while(digitalRead(KEYPAD_DA)==HIGH);
    return key;
  }
else
  return KEYPAD_NULL;
}

unsigned int keypad_get_integer(void){
  unsigned int value=0;
  unsigned char key;
  while(key=keypad_get_key()<0x0A){
    Serial.write(ASCII[key]);
    value=value*10+key;
  }
return value;
}

void setup(void){
  Serial.begin(9600);
}

void loop(void){
  unsigned char value;
  value=keypad_get_byte();
  Serial.println();Serial.println(value);
}
